#version 330 core

in vec2 TexCoords;
in vec3 Normal;
in vec3 FragPos;  

out vec4 color;

uniform sampler2D texture_diffuse1;

uniform vec3 lightColor;
uniform vec3 objectColorColor;
uniform vec3 lightPos;
uniform vec3 viewPos;

void main()
{    
	//Ambient light
	float ambientStrength = 0.3f;
    vec3 ambient = ambientStrength * lightColor;
	
	//Diffuse light
	vec3 norm = normalize(Normal);
	vec3 lightDir = normalize(lightPos - FragPos); 
	float diff = max(dot(norm, lightDir), 0.0);
    vec3 diffuse = diff * lightColor;	
	
	//Specular light
	float specularStrength = 0.6f;
	vec3 viewDir = normalize(viewPos - FragPos);
	vec3 reflectDir = reflect(-lightDir, norm); 
	float spec = pow(max(dot(viewDir, reflectDir), 0.0), 32);
	vec3 specular = specularStrength * spec * lightColor;  	

	//combination of lights
    color = (vec4(ambient, 1.0f) + vec4(diffuse, 1.0f) + vec4(specular, 1.0f)) * texture(texture_diffuse1, TexCoords);
 
 // GEHT NICHT WEGEN vec4!!!!!!!!!
	//vec3 result = (ambient + diffuse + specular) * texture(texture_diffuse1, TexCoords);
 //   color = vec4(result, 1.0f);

    //color = vec4(texture(texture_diffuse1, TexCoords) * lightColor);
}