#version 330 core
in vec2 TexCoords;

uniform sampler2D depthTexture;
uniform sampler2D renderedTexture;


float near = 1.0; //<-- VON KAMERA
float far  = 100.0;  //<-- VON KAMERA
  
float LinearizeDepth(float depth) 
{
    float z = depth * 2.0 - 1.0; // Back to NDC 
    return (2.0 * near * far) / (far + near - z * (far - near));	
}

const float offset = 1.0 / 800;  
uniform vec2 resolution;

//float toonify(in float intensity) {
//    if (intensity > 0.3)
//        return 1.0;
//    //else if (intensity > 0.5)
//    //    return 0.8;
//    else
//        return 0.3;
//}

void main()
{ 	
	float offset_x = 1.0 / (resolution.x*1.0);
	float offset_y = 1.0 / (resolution.y*1.0);

	vec2 offsets[9] = vec2[](
        vec2(-offset_x, offset_y),  // top-left
        vec2(0.0f,    offset_y),  // top-center
        vec2(offset_x,  offset_y),  // top-right
        vec2(-offset_x, 0.0f),    // center-left
        vec2(0.0f,    0.0f),    // center-center
        vec2(offset_x,  0.0f),    // center-right
        vec2(-offset_x, -offset_y), // bottom-left
        vec2(0.0f,    -offset_y), // bottom-center
        vec2(offset_x,  -offset_y)  // bottom-right    
    );

    float kernel_v[9] = float[](
        1, 0, -1,
        2, 0, -2,
        1, 0, -1
    );
	float kernel_h[9] = float[](
        1, 2, 1,
        0, 0, 0,
        -1, -2, -1
    );

	float gauss[9] = float[](
        0.077847, 0.123317, 0.077847,
		0.123317, 0.195346, 0.123317,
		0.077847, 0.123317, 0.077847
    );
    
	//ES REICHT FLOAT!!!!!!!!!!!!!!!!
    float sampleTex[9];
    for(int i = 0; i < 9; i++)
    {
        sampleTex[i] = LinearizeDepth(texture(depthTexture, TexCoords.st + offsets[i]).x) / far;
    }
    float col_v = 0.0f;
	float col_h = 0.0f;
    for(int i = 0; i < 9; i++)
        col_v += sampleTex[i] * kernel_v[i];
	for(int i = 0; i < 9; i++)
        col_h += sampleTex[i] * kernel_h[i];

	float temp = 1.0-sqrt(col_h*col_h+col_v*col_v);
	if (temp < 0.95f)
		temp = 0.0f;
	else
		temp = 1.0f;

	vec4 samples[9];
    for(int i = 0; i < 9; i++)
    {
        samples[i] = texture(renderedTexture, TexCoords + offsets[i]);
    }

	vec3 test;
	//float factor = toonify(max(test.r, max(test.g, test.b)));

	for(int i = 0; i < 9; i++)
	{
        test.r += samples[i].r * gauss[i];
		test.g += samples[i].g * gauss[i];
		test.b += samples[i].b * gauss[i];
	}

	gl_FragColor = vec4(vec3(temp), 1.0f)*vec4(test, 1.0f);
	//gl_FragColor = vec4(vec3(texture(renderedTexture, TexCoords).r), 1.0f);
	//gl_FragColor = vec4(vec3(temp), 1.0f)*(factor*texture(renderedTexture, TexCoords));
	//color = vec4(vec3(1.0-sqrt(col_h*col_h+col_v*col_v)), 1.0f)*texture(renderedTexture, TexCoords);
}