//#version 330 core
//layout (location = 0) in vec3 position;
//layout (location = 1) in vec3 normal;
//layout (location = 2) in vec2 texCoords;

//out vec2 TexCoords;

//uniform mat4 model;
//uniform mat4 view;
//uniform mat4 projection;

//void main()
//{
//    gl_Position = projection * view * model * vec4(position, 1.0f);
//    TexCoords = texCoords;
//}

//uniform sampler2D ourTexture1;
//uniform sampler2D ourTexture2;

//void main()
//{
//    color = mix(texture(ourTexture1, TexCoord), texture(ourTexture2, TexCoord), 0.2);
//}


#version 330 core
layout (location = 0) in vec3 position;
//layout (location = 1) in vec3 color;
layout (location = 2) in vec2 texCoord;

out vec2 TexCoord;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

void main()
{
	gl_Position = projection * view * model * vec4(position, 1.0f);
    TexCoord = vec2(texCoord.x, 1.0 - texCoord.y);
}


//#version version_number
  
//in type in_variable_name;
//in type in_variable_name;

//out type out_variable_name;
  
//uniform type uniform_name;
  
//void main()
//{
//  // Process input(s) and do some weird graphics stuff
//  ...
//  // Output processed stuff to output variable
//  out_variable_name = weird_stuff_we_processed;
//}

//#version 330 core

//layout (location = 0) in vec3 position; // The position variable has attribute position 0
//layout (location = 1) in vec3 color;	// The color variable has attribute position 1
  
//out vec3 ourColor; // Output a color to the fragment shader

//uniform vec3 Offset;

//void main()
//{
//    gl_Position = vec4(position+Offset, 1.0);
//    ourColor = color; // Set ourColor to the input color we got from the vertex data
//} 