#version 330 core

out vec4 color;
in vec2 textureCoords;
in vec3 toCameraVector;

uniform sampler2D waterTexture;
uniform sampler2D dudvMap;

uniform float moveFactor;

const float waveStrenght = 0.03;

struct Material
{
	sampler2D texture_diffuse1;
	sampler2D texture_specular1;
    float shininess;
}; 

uniform Material material;

void main()
{
    //gl_FragColor = vec4(0.0, 0.0, 1.0, 1.0);
	vec2 textureCoordinates = textureCoords;
	
	vec2 distortion = (texture(material.texture_specular1, vec2(textureCoordinates.x + moveFactor, textureCoordinates.y)).rg * 2.0 - 1.0) * waveStrenght;
	textureCoordinates += distortion;
	
	
	//vec3 a = vec3(texture(material.texture_specular1, textureCoordinates).r, texture(material.texture_specular1, textureCoordinates).g, texture(material.texture_specular1, textureCoordinates).b);
	vec4 reflectColour = texture(material.texture_specular1, textureCoordinates);
	
	//fresnel effect
	vec3 viewVector = normalize(toCameraVector);
	//spiegelungsfaktor
	float factor = dot(viewVector, vec3(0.0, 0.7,0.0));
	factor = pow(factor, 2.5);
	
	
	
	color = mix(reflectColour, texture(material.texture_diffuse1, textureCoords),0.35);
	color = mix(color, vec4(0.0, 0.3, 0.5, 1.0), 0.8);
	
	color = vec4(color.r, color.g, color.b, 1-factor); //transparenz
}