#version 330 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoords;

out vec2 textureCoords;
out vec3 toCameraVector;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform vec3 viewPos;

const float tiling = 6.0;

void main()
{
	vec4 worldPosition = model * vec4(position.x, 0.0, position.y, 1.0);
	gl_Position = projection * view *  model * vec4(position, 1.0f);
	textureCoords = vec2(texCoords.x/2.0 + 0.5, texCoords.y/2.0 + 0.5) * tiling;
	toCameraVector = viewPos - worldPosition.xyz;
}